/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 * Date: 2013.10.05
 */

#include <cstdio>

#include "random.h"

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

const int X = (int)1e9;

int main( int argc, char *argv[] )
{
  if (argc < 3)
  {
    puts("Usage: <seed for random> <n>");
    puts("  [seed == 0] => Time()");
    return 1;
  }

  int seed = atoi(argv[1]);
  int n = atoi(argv[2]);

  if (seed == 0)
    seed = Time(), fprintf(stderr, "seed = %d\n", seed);
  initrand(seed);

  n -= !(n & 1);
  printf("%d %d 3 5\n", n, 2 * (n / 2));
  forn(i, n / 2)
  {
    printf("+ o %d 2 %d %d\n", 2 * i + 1, 2 * i + 2, 2 * i + 3);
    printf("+ o %d 1 %d\n", 2 * i + 2, 2 * i + 3);
  }
  return 0;
}
